/** CRTransLib for BLCR v0.8.0 checkpointer
 * @author John Mehnert-Spahn, Ralph-Gordon Paul and Eugen Feller
 *
 * Copyright (c) 2008 Heinrich-Heine-Universitaet Duesseldorf
 * All rights reserved.
 *
 * This file is part of AEM. AEM is part of XtreemOS, a Linux-based Grid
 * Operating System, see <http://www.xtreemos.eu> for more details. The
 * XtreemOS project has been developed with the financial support of the
 * European Commission's IST program under contract #FP6-033576.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *     * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *     * Neither the name of the XtreemOS project nor the names of its
 *     partners and/or contributors may be used to endorse or promote
 *     products derived from this software without specific prior written
 *     permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef CRTRANSLIB_BLCR_H
#define CRTRANSLIB_BLCR_H

#include <stdio.h>
#include <sys/syscall.h>
#include <errno.h>
#include <unistd.h>
#include <sched.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/msg.h>
#include <sys/signal.h>
#include <dirent.h>
#include <pthread.h>
#include <sched.h>
#include <errno.h>
#include <libcr.h>
#include <sys/mman.h>
#include <sys/fcntl.h>
#include <getopt.h>
#include <signal.h>

typedef struct xos_blcr_file{
	int thread_number;
} xos_blcr_file_t;

#define XOS_BLCR_PATH "/xtreemfs/blcr/"	// Path to the XOS and BLCR Content (Image Files, etc.)

#define XOS_MSG_QUEUE XOS_BLCR_PATH "queue"	// for Message Queue Creation
#define XOS_MSG_QUEUE_ID 'x'				// for Message Queue Creation

#define XOS_SEM_KEY XOS_BLCR_PATH "semaphore"
#define XOS_SEM_ID 'y'


#define XOS_MSG_MAX_LENGTH 30				// Maximun length of a Message

// Message Types - use message queue to communicate with BLCR to realise coordinated cp/rst
#define XOS_MSG_CALLBACKS 1
#define XOS_MSG_CBS_DONE 2
#define XOS_MSG_CHKPT 3
#define XOS_MSG_CHKPT_DONE 4
#define XOS_MSG_RST_DONE 5
#define XOS_MSG_RESUME 6

/* Importiant */
#define PGR_ID_FILE_SIZE 100
#define CMD_SIZE 256
#define THREAD_OF_PROCESSES 100

union semun {
	int val;
	struct semid_ds *buf;
	ushort * array;
} sem_argument;


#endif /* CRTRANSLIB_BLCR_H */
